[Index](/README.md) | [Specification](/documentation/specification.md) | [Sandbox/demo](/demo/README.md)  | [Deployment](/documentation/deployment.md) | [Typescript SDK Quick start](/documentation/Quickstart.md) | [Examples](/documentation/Examples.md) | [Tezos Sandbox Mempool](/tezos-sandbox-mempool/README.md)

# Token Management

## Generate admin token

At database initialization, a new admin token should be generated. It can be achieved as follows:

* go to the **token-management** directory;

* update the JWT secret in the **config.sh** file to match the one set in the REST transaction manager **application.yml** config file;

* generate a new admin token.

```shell
./generateAdminToken.sh
```

__Expected answer__:
```shell
Generate admin token

Admin token generated:
{
  "id": "61af86271713ec1238148d63",
  "name": "admin",
  "creationDate": "2021-12-07T17:04:55.807318+01:00",
  "roles": [
    "ADMIN"
  ],
  "owner": "61af86271713ec1238148d62",
  "revoked": false,
  "jwtToken": "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJvd25lciI6IjYxYWY4NjI3MTcxM2VjMTIzODE0OGQ2MiIsImNyZWF0aW9uVGltZSI6IjIwMjEtMTItMDdUMTc6MDQ6NTUuODA5NTgzKzAxOjAwIiwicm9sZXMiOlsiQURNSU4iXSwiaXNzIjoiVGV6b3NAQ3liIiwicGVyc2lzdGVkIjp0cnVlfQ.bEj5CS973rAZFAHKmlnNH1tpGW_0tOkpLL8rYiE2PIE"
}
Please save this token, it will not be given to you again.

Revoke temporary admin token

Temporary admin token revoked.
```

## Generate issuer token

* go to the **token-management** directory;

* update the **admin_token** in the **config.sh** file with the admin token generated by **generateAdminToken**;

__Example__:
```shell
admin_token=eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJvd25lciI6IjYxYWY4NjI3MTcxM2VjMTIzODE0OGQ2MiIsImNyZWF0aW9uVGltZSI6IjIwMjEtMTItMDdUMTc6MDQ6NTUuODA5NTgzKzAxOjAwIiwicm9sZXMiOlsiQURNSU4iXSwiaXNzIjoiVGV6b3NAQ3liIiwicGVyc2lzdGVkIjp0cnVlfQ.bEj5CS973rAZFAHKmlnNH1tpGW_0tOkpLL8rYiE2PIE
```

* generate a new issuer token with a name (replace `my_issuer` with the name you want for the issuer token).

```shell
./generateIssuerToken.sh my_issuer
```

__Expected answer format__:
```shell
Generate issuer token

Issuer token generated:
{
  "id": "61af86791713ec1238148d65",
  "name": "my_issuer",
  "creationDate": "2021-12-07T17:06:17.401534+01:00",
  "roles": [
    "ISSUER"
  ],
  "owner": "61af86791713ec1238148d64",
  "revoked": false,
  "jwtToken": "eyJ0eXAiOiJKV1QiLCJhbGciOiJIUzI1NiJ9.eyJvd25lciI6IjYxYWY4Njc5MTcxM2VjMTIzODE0OGQ2NCIsImNyZWF0aW9uVGltZSI6IjIwMjEtMTItMDdUMTc6MDY6MTcuNDA0ODEwKzAxOjAwIiwicm9sZXMiOlsiSVNTVUVSIl0sImlzcyI6IlRlem9zQEN5YiIsInBlcnNpc3RlZCI6dHJ1ZX0.hICb3MCaG3jUb5kZiy28sl2Y1qrXcZoO7N4HffgqC9Q"
}
Please save this token, it will not be given to you again.
```

* send the generated issuer token to the issuer.
